#include <ble_infrastructure.h>
#include <stdbool.h>
#include <stdint.h>

#include "nrf.h"
#include "nordic_common.h"

#include "nrf_log.h"
#include "nrf_log_ctrl.h"
#include "nrf_log_default_backends.h"
#include "nrfx_spim.h"

#include "ble_infrastructure.h"
#include "power.h"

static void log_init(void) {
	ret_code_t err_code = NRF_LOG_INIT(NULL);
	APP_ERROR_CHECK(err_code);

	NRF_LOG_DEFAULT_BACKENDS_INIT();
}

static const nrfx_spim_t spim = NRFX_SPIM_INSTANCE(3);
static uint8_t       m_tx_buf[2];           /**< TX buffer. */
static uint8_t       m_rx_buf[3];    /**< RX buffer. */

static void spi_init() {
    nrfx_spim_config_t spi_config = NRFX_SPIM_DEFAULT_CONFIG;
    spi_config.ss_pin   = SPI_SS_PIN;
    spi_config.miso_pin = SPI_MISO_PIN;
    spi_config.mosi_pin = SPI_MOSI_PIN;
    spi_config.sck_pin  = SPI_SCK_PIN;
    APP_ERROR_CHECK(
    		nrfx_spim_init(&spim, &spi_config, NULL, NULL));
}



void spi_write() {
	m_tx_buf[0] = 0x42;
	m_tx_buf[1] = 0x42;
	nrfx_spim_xfer_desc_t xfer = NRFX_SPIM_SINGLE_XFER(m_tx_buf, 2, m_rx_buf, 2);
	APP_ERROR_CHECK(nrfx_spim_xfer(&spim, &xfer, 0));
}

int main(void) {

    power_management_init();
    log_init();
    NRF_LOG_INFO("Hello");
	ble_init();
    spi_init();
    spi_write();
    while(1) {
	    NRF_LOG_INFO("I am fine");
        idle_state_handle();
    }
}

