#include "nrf_pwr_mgmt.h"
#include "app_error.h"
#include "nrf_log.h"
#include "nrf_log_ctrl.h"
#include "nrfx_power.h"

#define NRF52_ONRAM1_OFFRAM1  	POWER_RAM_POWER_S0POWER_On      << POWER_RAM_POWER_S0POWER_Pos      \
												      | POWER_RAM_POWER_S1POWER_On      << POWER_RAM_POWER_S1POWER_Pos      \
												      | POWER_RAM_POWER_S0RETENTION_On  << POWER_RAM_POWER_S0RETENTION_Pos  \
	                            | POWER_RAM_POWER_S1RETENTION_On  << POWER_RAM_POWER_S1RETENTION_Pos;

#define NRF52_ONRAM1_OFFRAM0    POWER_RAM_POWER_S0POWER_On      << POWER_RAM_POWER_S0POWER_Pos      \
												      | POWER_RAM_POWER_S1POWER_On      << POWER_RAM_POWER_S1POWER_Pos      \
												      | POWER_RAM_POWER_S0RETENTION_Off << POWER_RAM_POWER_S0RETENTION_Pos  \
	                            | POWER_RAM_POWER_S1RETENTION_Off << POWER_RAM_POWER_S1RETENTION_Pos;

#define NRF52_ONRAM0_OFFRAM0    POWER_RAM_POWER_S0POWER_Off     << POWER_RAM_POWER_S0POWER_Pos      \
												      | POWER_RAM_POWER_S1POWER_Off     << POWER_RAM_POWER_S1POWER_Pos;

void configure_ram_retention(void) {
		// Configure nRF52 RAM retention parameters. Set for System On 64kB RAM retention
		NRF_POWER->RAM[0].POWER = NRF52_ONRAM1_OFFRAM1;
		NRF_POWER->RAM[1].POWER = NRF52_ONRAM1_OFFRAM1;
		NRF_POWER->RAM[2].POWER = NRF52_ONRAM1_OFFRAM1;
		NRF_POWER->RAM[3].POWER = NRF52_ONRAM1_OFFRAM1;
		NRF_POWER->RAM[4].POWER = NRF52_ONRAM1_OFFRAM1;
		NRF_POWER->RAM[5].POWER = NRF52_ONRAM1_OFFRAM1;
		NRF_POWER->RAM[6].POWER = NRF52_ONRAM1_OFFRAM1;
		NRF_POWER->RAM[7].POWER = NRF52_ONRAM1_OFFRAM1;
}

void power_management_init(void) {
    ret_code_t err_code;
    err_code = nrf_pwr_mgmt_init();
    APP_ERROR_CHECK(err_code);
}

void idle_state_handle(void) {
	NRF_LOG_FINAL_FLUSH();
	nrf_pwr_mgmt_run();
}

bool is_usb_power_connected() {
	nrfx_power_usb_state_t power_state = nrfx_power_usbstatus_get();
	return NRFX_POWER_USB_STATE_CONNECTED == power_state || NRFX_POWER_USB_STATE_READY == power_state;
}

void soft_reset() {
	nrf_pwr_mgmt_shutdown(NRF_PWR_MGMT_SHUTDOWN_RESET);
}
